/* ************************************************
 *				  ELIMINAR TABLAS				  *
 * ************************************************/

DROP TABLE IF EXISTS Log;
DROP TABLE IF EXISTS Complemento;
DROP TABLE IF EXISTS Peticion;
DROP TABLE IF EXISTS Modelo;
DROP TABLE IF EXISTS Album;
DROP TABLE IF EXISTS Usuario;




/* ************************************************
 *				  CREACION TABLAS				  *
 * ************************************************/

 CREATE TABLE Usuario (
	id INTEGER AUTO_INCREMENT NOT NULL,
	nick VARCHAR(20) NOT NULL UNIQUE,
	nombre VARCHAR(20),
	apellidos VARCHAR(30),
	email VARCHAR(101) NOT NULL,
	password VARCHAR(81) NOT NULL,
	estado INTEGER NOT NULL DEFAULT '0',
	validar VARCHAR(50) NOT NULL,
	fechaNac DATE,
	telefono CHAR(12),
	CONSTRAINT IdDelCliente PRIMARY KEY(id)
);

/* INSERT INTO `usuario`(`id`,`nick`, `nombre`, `apellidos`, `email`, `password`, `estado`,`validar` , `fechaNac`, `telefono`) VALUES (0,'IvI','Ivn','Martn Prez','ivan.martin2020@gmail.com','1234','1','cfnna','1989-10-05','646224507')
* INSERT INTO `usuario`(`id`,`nick`, `nombre`, `apellidos`, `email`, `password`, `estado`,`validar` , `fechaNac`, `telefono`) VALUES (0,'ARkivia','AR','kivia','ARkivia','123456789','5','','1989-11-05','')
*INSERT INTO `album`(`id`, `nombre`, `descripcion`, `imagen`, `idUsuario`) VALUES (99,"Sin clasificar","Sin definir","/images/album.jpg",99)
*	on delete cascade de usuario a album y de album a modelos y de objetos
*/

CREATE TABLE Album (
	id INTEGER AUTO_INCREMENT NOT NULL,
	nombre VARCHAR(40) NOT NULL,
	descripcion VARCHAR(140),
	imagen VARCHAR(100) DEFAULT '/images/album.jpg',
	idUsuario INTEGER NOT NULL,
	CONSTRAINT IdDelAlbum PRIMARY KEY(id),
 	CONSTRAINT ususario_albumFk FOREIGN KEY (idUsuario) REFERENCES Usuario (id) ON DELETE CASCADE
);

CREATE TABLE Modelo (
	id INTEGER AUTO_INCREMENT NOT NULL,
	idAlbum INTEGER NOT NULL,
	nombre VARCHAR(40) NOT NULL,
	descripcion VARCHAR(140),
	modelo VARCHAR(100) NOT NULL,
	mtl VARCHAR(100) NOT NULL,
	privado BOOLEAN NOT NULL,
	imagen VARCHAR(100) DEFAULT '/images/modelo.png',
	categoria VARCHAR(50) DEFAULT 'Sin categoria',
	fechaMod TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
	pendiente BOOLEAN NOT NULL,
	CONSTRAINT IdModelo PRIMARY KEY(id),
	CONSTRAINT album_modeloFk FOREIGN KEY (idAlbum) REFERENCES Album (id) ON DELETE CASCADE
);
CREATE TABLE Complemento (
	id INTEGER AUTO_INCREMENT NOT NULL,
	idModelo INTEGER NOT NULL,
	complemento VARCHAR(100) NOT NULL,
	nombre VARCHAR(40) NOT NULL,
	descripcion VARCHAR(140),
	CONSTRAINT IdDelModelo PRIMARY KEY(id),
	CONSTRAINT modelo_objetoFk FOREIGN KEY (idModelo) REFERENCES Modelo (id) ON DELETE CASCADE
);
CREATE TABLE Peticion (
	id INTEGER AUTO_INCREMENT NOT NULL,
	idEmisor INTEGER NOT NULL,
	idModelo INTEGER NOT NULL,
	archivo VARCHAR(100) NOT NULL,
	mensaje VARCHAR(180),
	pendiente BOOLEAN,
	resolucion BOOLEAN,
	fecha  TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
	CONSTRAINT IdPeticion PRIMARY KEY(id),
	CONSTRAINT Peticion_ModeloFk FOREIGN KEY (idModelo) REFERENCES Modelo (id) ON DELETE CASCADE,
	CONSTRAINT Peticion_EmisorFk FOREIGN KEY (idEmisor) REFERENCES Usuario (id) ON DELETE CASCADE
);

CREATE TABLE Log (
	id INTEGER AUTO_INCREMENT NOT NULL,
	idUsuario INTEGER NOT NULL,
	accion VARCHAR(180),
	param1 VARCHAR(80),
	param2 VARCHAR(80),
	fechaMod TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
	CONSTRAINT IdPeticion PRIMARY KEY(id)
);


INSERT INTO `Usuario`(`id`,`nick`, `nombre`, `apellidos`, `email`, `password`, `estado`,`validar` , `fechaNac`, `telefono`) VALUES (99,'ARkivia','AR','kivia','ARkivia','123456789','5','','1989-11-05','');
INSERT INTO `Album`(`id`, `nombre`, `descripcion`, `imagen`, `idUsuario`) VALUES (99,"Sin clasificar","Sin definir","/images/album.jpg",99);
/*
*aadir la carpeta  f6df214b4b0ec8ea77685ca906494015d9f9e772 y dentro una carpeta modelos
*/